         ;
         ; ----------------------
         ; Binning plot y=bin(x) 
         ; called by plt_map.pro
         ; ----------------------
         ;
               IF debug_w THEN print, "    "
               IF debug_w THEN print, "    Enter ybinx..."
               IF debug_w THEN print, "    "
               
               ; organise bins: either read array or build form single number and min/max in fld_glo_mmx.def
               ; fld2 is the field being bined

               IF (size(bin_interval))(0) EQ 1 THEN BEGIN 
                   ; build... 
               ENDIF 

               nbins = (size(bin_interval))(1)

               bin_plt = (bin_interval+shift(bin_interval, -1))/2
               bin_plt = [2*bin_plt(0)-bin_plt(1), bin_plt[0:nbins-2], 2*bin_plt(nbins-2)-bin_plt(nbins-3)]

               IF debug_w THEN print, '    bin_plt= ', bin_plt 
               IF debug_w THEN print, '      nbins= ', nbins

               ; 3rd field to bin regression ?

               IF var3_ybinx NE "" THEN sw3 = 1 ELSE sw3 = 0

               ; mask fields with valmask for regression computation

               IF sw3 THEN BEGIN 
                  idxmsk = where(fld GT valmask/10.)
                  IF idxmsk(0) NE -1 THEN fld(idxmsk) = valmask
                  IF idxmsk(0) NE -1 THEN fld3(idxmsk) = valmask
               ENDIF 

               ; ensure masks are the same

               idxmskpn = where(finite(fld, /nan))
               idxmskpn2 = where(finite(fld2, /nan))
               IF idxmskpn(0) NE -1 THEN fld(idxmskpn) = valmask
               IF idxmskpn2(0) NE -1 THEN fld2(idxmskpn2) = valmask

               idxmskpn = where(fld GT valmask/10.)
               idxmskpn2 = where(fld2 GT valmask/10.)
               IF idxmskpn(0) NE -1 THEN fld2(idxmskpn) = valmask
               IF idxmskpn2(0) NE -1 THEN fld(idxmskpn2) = valmask

               ; print min/max of field for debug
               idxmskp = where(fld LE valmask/10.)
               IF debug_w THEN print, '    Min/max fld= ', min(fld(idxmskp)), max(fld(idxmskp))
               IF debug_w THEN print, '    Min/max fld2= ', min(fld2(idxmskp)), max(fld2(idxmskp))

               ; remove mean seasonal cycle if required

               IF cmd.trend GT 0 THEN BEGIN
                  fld = trends(fld, cmd.trend, 'xyt')
                  IF sw3 THEN fld3 = trends(fld3, cmd.trend, 'xyt')
               ENDIF 
               IF cmd2.trend GT 0 THEN BEGIN
                  fld2 = trends(fld2, cmd2.trend, 'xyt')
               ENDIF 

               ; select months if required

               CASE cmd.timave OF 
                  '1d': ntxt = "All days"
                  ELSE :ntxt = "All months"
               ENDCASE 

               IF stddev_mth NE '00' THEN BEGIN 
                  @mth_decode

                  fldn = (fld)[*, *, reform(idxm(0,*), njpt)]
                  fld2n = (fld2)[*, *, reform(idxm(0,*), njpt)]
                  IF sw3 THEN fld3n = (fld3)[*, *, reform(idxm(0,*), njpt)]

                  FOR imth = 1, nmth-1 DO BEGIN 
                                       
                  fldn = [fldn, (fld)[*, *, reform(idxm(imth,*), njpt)]]
                  fld2n = [fld2n, (fld2)[*, *, reform(idxm(imth,*), njpt)]]
                  IF sw3 THEN fld3n = [fld3n, (fld3)[*, *, reform(idxm(imth,*), njpt)]]

                  ENDFOR 
                  jpt = njpt

                  fld = fldn
                  fld2 = fld2n
                  IF sw3 THEN fld3 = fld3n
               ENDIF 

               ; for now just 2d fields
;               IF nzt NE 1 THEN BEGIN 
;                  print, '***** 2D field only for now in ybinx ****'
;                  stop
;               ENDIF 

               ; find indexes of var2 in each bin

               idxb = lonarr(nbins+1, nxt*nyt*jpt)
               binpop = lonarr(nbins+1)

               ib = 1

               WHILE ib LE nbins-1 DO BEGIN 

                  indices = where(fld2 GT bin_interval(ib-1) AND fld2 LE bin_interval(ib))
                  binpop(ib) = n_elements(indices) 
                  idxb[ib, 0:binpop(ib)-1] = where(fld2 GT bin_interval(ib-1) AND fld2 LE bin_interval(ib))
                  IF debug_w THEN print, '    Size of bin(i) ', ib, binpop(ib) 

                  ib = ib + 1
               ENDWHILE 

               index0 = where(fld2 LE bin_interval(0))
               binpop(0) =  n_elements(index0)
               idxb(0, 0:binpop(0)-1) = index0

               indexm = n_elements(where(fld2 GT bin_interval(nbins-1))) 
               binpop(nbins) = n_elements(indexm)
               idxb(nbins, 0:binpop(nbins)-1) = indexm

               ; compute maximum number of indices for one bin

               max_idx = max(binpop)

               IF debug_w THEN print, '    Max bin size ', max_idx
               IF debug_w THEN print, '    Number of bins ', nbins
               fldy = fltarr(nbins+1, max_idx)
               fldy[*, *] = !values.f_nan 
               fldys = fltarr(nbins+1, max_idx)
               fldys[*, *] = !values.f_nan 
               surfb = fltarr(nbins+1, max_idx)
               surfb[*, *] = !values.f_nan 

               IF sw3 THEN BEGIN 
                  fldy2 = fltarr(nbins+1, max_idx)
                  fldy2[*, *] = !values.f_nan
               ENDIF 

               ; extract fld1/fld3 arrays in each bin

               ; first build fld*e1te2t for later average

               surf = reform(e1t(firstxt:lastxt,firstyt:lastyt)*e2t(firstxt:lastxt,firstyt:lastyt), nxt*nyt)
               surf = reform(surf#replicate(1, jpt), nxt, nyt, jpt)

               flds = fld*surf

               ib = 0
               WHILE ib LE nbins DO BEGIN 
                  
                  IF debug_w THEN print, 'bin = ', ib
                  binsz = binpop(ib)
                  IF binsz GT 1 THEN BEGIN 
                     fldy(ib, 0:binsz-1) = fld(idxb(ib, 0:binsz-1))
                     IF debug_w THEN print, 'fld(idxb(ib, 0:binsz-1)) =',fld(idxb(ib, 0:binsz-1)) 
                     fldys(ib, 0:binsz-1) = flds(idxb(ib, 0:binsz-1))
                     surfb(ib, 0:binsz-1) = surf(idxb(ib, 0:binsz-1))
                     IF sw3 THEN fldy2(ib, 0:binsz-1) = fld3(idxb(ib, 0:binsz-1))
                  ENDIF 
                  ib = ib + 1
               ENDWHILE 


               yplt = fltarr(nbins+1)
               yerr = fltarr(nbins+1)

               IF NOT sw3 THEN BEGIN 

                 ; if bining only fld1, compute average in each bin and plot
                  ; average

                  mean_fld = 0.

                  ib = 0
                  WHILE ib LE nbins DO BEGIN 
                     
                     binsz = binpop(ib)
                     
                     IF binsz GT 1 THEN BEGIN  

                        sfc_tot = total(surfb(ib, 0:binsz-1))
                        yplt(ib) = total(fldys(ib, 0:binsz-1))/sfc_tot
                        yerr(ib) = sqrt((moment(fldy(ib, 0:binsz-1)))[1])

                        mean_fld = mean_fld + yplt(ib)*float(binpop(ib)) 

                        ; print bin info
                        IF ib GT 0 AND ib LT nbins THEN print, '    Bin size, occurence, average: ', bin_interval(ib-1), bin_interval(ib), binpop(ib), (binpop(ib)/total(binpop))*100., yplt(ib)
                        IF ib EQ 0 THEN print, '    Bin size, occurence, average:      min' , bin_interval(ib), binpop(ib), (binpop(ib)/total(binpop))*100. , yplt(ib)
                        IF ib EQ nbins THEN print, '    Bin size, occurence, average: ', bin_interval(ib-1),'     max ', binpop(ib), (binpop(ib)/total(binpop))*100. , yplt(ib)
                     ENDIF ELSE yplt(ib) = !values.f_nan
                  
                     ib = ib + 1
                  ENDWHILE 

                  mean_fld = mean_fld/total(binpop)

                  print, '    Total number of bins = ', total(binpop)
                  print, '    Mean field in domain = ', mean_fld
               
                  ; specify plot attributes
                  varname = varlegend2

               ENDIF ELSE BEGIN 
                  ; if bining fld1=f(fld3), compute regression in each bin and plot

                  ; compute regression for each bin

                  mean_fld = 0.

                  ib = 0
                  WHILE ib LE nbins DO BEGIN 

                     binsz = binpop(ib)

                     IF binsz GT 1 THEN BEGIN 

                        idx1 = where(fldy(ib, 0:binsz-1) NE valmask)
                        idx2 = where(fldy2(ib, 0:binsz-1) NE valmask)
                        tab1 = (fldy(ib, 0:binsz-1))(idx1)
                        tab2 = (fldy2(ib, 0:binsz-1))(idx2)
                        coeff = linfit(tab2, tab1, CHISQ = linerr, PROB = proberr, SIGMA = sigmaerr)
                        yplt(ib) = coeff(1)
                        yerr(ib) = sigmaerr(1)

                        mean_fld = mean_fld + yplt(ib)*float(binpop(ib)) 

                        ; print bin info
                        IF ib GT 0 AND ib LT nbins THEN print, '    Bin size, occurence, regress.: ', bin_interval(ib-1), bin_interval(ib), binpop(ib), (binpop(ib)/total(binpop))*100., yplt(ib)
                        IF ib EQ 0 THEN print, '    Bin size, occurence, regress.:      min' , bin_interval(ib), binpop(ib), (binpop(ib)/total(binpop))*100. , yplt(ib)
                        IF ib EQ nbins THEN print, '    Bin size, occurence, regress.: ', bin_interval(ib-1),'     max ', binpop(ib), (binpop(ib)/total(binpop))*100. , yplt(ib)

                     ENDIF ELSE yplt(ib) = !values.f_nan

                     ib = ib + 1
                  ENDWHILE 

                  mean_fld = mean_fld/total(binpop)

                  print, '    Total number of bins      = ', total(binpop)
                  print, '    Mean regression in domain = ', mean_fld

                  ; specify plot attributes
                  varname = 'Regression of '+field.name+' and '+field.name3

               ENDELSE 

               ; plot

               ; define text, line color, thickness and type

               boxybinx = def_box(cmd.plt, dimplot, leg_name, time_stride)
               vardate = date_txt
               varunit = ' ['+ntxt+' in box '+leg_name+']'

               overc = overlay_type(iover, dimplot)

               pltcmd = 'pltsc,yplt,bin_plt,minc,maxc,minc2,maxc2,varlegend'+com_strplt+overc+',STY1D=-6,subtitle=""'
               
               printf, nulhis, strcompress(pltcmd)
               IF debug_w THEN print, '   ', pltcmd
               res = execute(pltcmd)      

               ; plot +/- 1 stdedv for field binnig

               pltcmd = 'pltsc,yplt-yerr,bin_plt,minc,maxc,minc2,maxc2,varlegend'+com_strplt+',ov1d=1,COLOR=1, thick=1, STY1D=-1,subtitle=""'
               res = execute(pltcmd)      
               pltcmd = 'pltsc,yplt+yerr,bin_plt,minc,maxc,minc2,maxc2,varlegend'+com_strplt+',ov1d=1,COLOR=1, thick=1, STY1D=-1,subtitle=""'
               res = execute(pltcmd)      

               IF debug_w THEN print, "    ... Exit ybinx"
